package com.xin.shardingspherejdbcdemo.utils;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class JdbcUtils {
    static {
        try {
            Class.forName("com.mysql.cj.jdbc.Driver");//加载数据库驱动
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }

    public static List<String> queryTable(String ip, String port, String dbName, String username, String password, String tableName) throws SQLException {
        List<String> tables = new ArrayList<>();
        String url = "jdbc:mysql://" + ip + ":" + port + "/" + dbName;
        Connection conn = null;
        //2.获取与数据库的链接
        conn = DriverManager.getConnection(url, username, password);
        String sql = "select table_name from information_schema.tables where table_schema=? AND table_name LIKE ?";
        //3.获取用于向数据库发送sql语句的Preperedstatement
        PreparedStatement st = conn.prepareStatement(sql);//在此次传入，进行预编译
        st.setString(1, dbName);
        st.setString(2, tableName+"%");
        ResultSet rs = st.executeQuery();
        //循环取出
        if (rs.next()) {
            String id = rs.getString("table_name");//1代表数据库中表的列数，id在第一列也可以("id")！！！
            System.out.println(id + " ");
            tables.add(id);
        }
        //6.关闭链接，释放资源
        if (rs != null) {
            try {
                rs.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            rs = null;
        }
        if (st != null) {
            try {
                st.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if (conn != null) {
            try {
                conn.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return tables;

    }

    public static boolean createTable(String ip, String port, String dbName, String username, String password, String tableName) throws SQLException {
        boolean flage = false;
        String url = "jdbc:mysql://" + ip + ":" + port + "/" + dbName;
        Connection conn = null;
        //2.获取与数据库的链接
        conn = DriverManager.getConnection(url, username, password);
        String splitStr = "_";
        //3.获取用于向数据库发送sql语句的statement
        String[] s = tableName.split(splitStr);
        Integer year = Integer.valueOf(s[2]);
        year = year - 1;
        String oldTableName = s[0] + splitStr + s[1] + splitStr + year;
        //4.向数据库发sql
        String sql = "select table_name from information_schema.tables where table_schema=? AND table_name=? ";
        //3.获取用于向数据库发送sql语句的Preperedstatement
        PreparedStatement st = conn.prepareStatement(sql);//在此次传入，进行预编译
        st.setString(1, dbName);
        st.setString(2, tableName);
        ResultSet rs = st.executeQuery();
        //循环取出(id)
        flage = rs.next();
        if (!flage) {
            Statement statement = conn.createStatement();
            sql = "CREATE TABLE IF NOT EXISTS" + tableName + " LIKE " + oldTableName;
            //3.获取用于向数据库发送sql语句的Preperedstatement
            flage = statement.execute(sql);
        }

        //6.关闭链接，释放资源
        if (rs != null) {
            try {
                rs.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            rs = null;
        }
        if (st != null) {
            try {
                st.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if (conn != null) {
            try {
                conn.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return flage;

    }
}
